//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormSettings.h"
#include "ComPort.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmSettings *frmSettings = NULL;
//---------------------------------------------------------------------------
__fastcall TfrmSettings::TfrmSettings(TComponent* Owner)
	: TForm(Owner)
{
	pages->ActivePage = tsGeneral;
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::btnCancelClick(TObject *Sender)
{
	this->Close();	
}
//---------------------------------------------------------------------------
void __fastcall TfrmSettings::btnApplyClick(TObject *Sender)
{
	comPort = cbSerialPort->Text;

	confirmed = true;
	this->Close();
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::FormKeyPress(TObject *Sender, char &Key)
{
	if (Key == VK_ESCAPE)
	{
		Close();
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSettings::FormShow(TObject *Sender)
{
    confirmed = false;
	ModalResult = mrNone;

	{
		// serial ports list
		std::vector<struct ComPort::S_COM_PORT> ports;
		if(ComPort::EnumeratePortsAlt()) {
			//LOG("Error enumerating ports");
		}
		ports = ComPort::GetPorts();
		cbSerialPort->Items->Clear();
		for(unsigned int i=0; i<ports.size(); i++) {
			cbSerialPort->Items->Add(ports[i].name.c_str());
		}
		if(ports.size()) {
			cbSerialPort->ItemIndex = 0;
		} else {
			cbSerialPort->ItemIndex = -1;
		}
	}	

	cbSerialPort->Text = comPort;
}
//---------------------------------------------------------------------------

